# kip computer

The kip is a fantasy computer based on the 32-bit kmx20 stack processor. This repository holds an SDL2-based C11 emulator.

## Build

### Requirements

* A C11 Compiler
* Meson + Ninja
* SDL2
* The source tree

### Acquiring the source

Kip is hosted on git at [git.cro.wtf/kip.git](https://git.cro.wtf/kip.git/), and is mirrored at [git.vern.cc/kcp/kip](https://git.vern.cc/kcp/kip).

### Building

```
$ git clone https://git.cro.wtf/kip.git
$ cd kip
$ meson setup b
$ meson compile -C b
$ meson test -C b # optional, just run tests
```

## Repository layout

* `./kip*` - sdl2-based emulator source files
* `./as.c` - assembler source
* `./d/` - documentation
* `./t/` - tests
* `./v/` - vim support
* `./w/` - doc -> html -> www
* `./x/` - examples

You can find more examples of code at [git.cro.wtf/kcp/mow.git](https://git.cro.wtf/kcp/mow.git).

## Copying

The entire kip codebase is under the 2-clause BSD license. See the `LICENSE` file included with the source tree for more information.

Basically: You are free to copy, modify, and redistribute this codebase in any way, as long as the copyright notice in `LICENSE` is provided with it.

## Contributing

Patches, questions, comments welcome: [kitty+kip@piapiac.org](mailto:kitty+kip@piapiac.org)

You can open issues and pull requests at [git.vern.cc/kcp/kip](https://git.vern.cc/kcp/kip)

Pull the most updated git repository from [git.cro.wtf/kip.git](https://git.cro.wtf/kip.git)
